From 9a6a24c37274164bababab75347808529d595664 Mon Sep 17 00:00:00 2001
From: santhosh hassan <sahassan@google.com>
Date: Thu, 14 Feb 2019 12:00:02 -0800
Subject: [PATCH 21/29] TEMP: NOT FOR REVIEW: google/mistral: Add board ID API

BUG=None
TEST=Verified GPIO assignment and board ID values.
BRANCH=None

Change-Id: Ic81b41f799c7bfc47a0daee705db1c01cd0af1a3
Signed-off-by: Santhosh Hassan <sahassan@google.com>
---
 src/mainboard/google/mistral/Makefile.inc |  3 ++
 src/mainboard/google/mistral/boardid.c    | 46 +++++++++++++++++++++++++++++++
 2 files changed, 49 insertions(+)
 create mode 100644 src/mainboard/google/mistral/boardid.c

diff --git a/src/mainboard/google/mistral/Makefile.inc b/src/mainboard/google/mistral/Makefile.inc
index 63bb49def936..ab81a739333b 100644
--- a/src/mainboard/google/mistral/Makefile.inc
+++ b/src/mainboard/google/mistral/Makefile.inc
@@ -3,6 +3,7 @@ bootblock-y += memlayout.ld
 bootblock-y += reset.c
 bootblock-y += bootblock.c
 
+verstage-y += boardid.c
 verstage-y += memlayout.ld
 verstage-y += chromeos.c
 verstage-y += reset.c
@@ -13,7 +14,9 @@ romstage-y += chromeos.c
 romstage-y += reset.c
 romstage-y += romstage.c
 romstage-y += romstage.c
+romstage-y += boardid.c
 
+ramstage-y += boardid.c
 ramstage-y += memlayout.ld
 ramstage-y += chromeos.c
 ramstage-y += reset.c
diff --git a/src/mainboard/google/mistral/boardid.c b/src/mainboard/google/mistral/boardid.c
new file mode 100644
index 000000000000..7fba34be5fd5
--- /dev/null
+++ b/src/mainboard/google/mistral/boardid.c
@@ -0,0 +1,46 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright 2018 Google LLC
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <boardid.h>
+#include <gpio.h>
+#include <console/console.h>
+#include <stdlib.h>
+
+/*
+ * Mistral boards dedicate to the board ID three GPIOs in ternary mode: 105, 106
+ * and 107.
+ */
+
+static uint32_t board_id_val = UNDEFINED_STRAPPING_ID;
+
+static uint32_t get_board_id(void)
+{
+	uint32_t bid;
+	const gpio_t pins[] = {[2] = GPIO(107),
+				[1] = GPIO(106),
+				[0] = GPIO(105)};
+
+	bid = gpio_binary_first_base3_value(pins, ARRAY_SIZE(pins));
+
+	return bid;
+}
+
+uint32_t board_id(void)
+{
+	if (board_id_val == UNDEFINED_STRAPPING_ID)
+		board_id_val = get_board_id();
+
+	return board_id_val;
+}
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

